#include <iostream>
#include "LinkedList.h"
using namespace std;

Node *LinkedList::remove_head()
{
    if (head == nullptr) return nullptr;

    Node *removed_head = head;
    head = head->next;

    // Is the list now empty?
    if (head == nullptr) tail = nullptr;

    size--;
    return removed_head;
}

void LinkedList::add(const Element& elmt)
{
    Node *node = new Node(elmt);
    add(node);
}

void LinkedList::add(Node *node)
{
    // First node.
    if (head == nullptr)
    {
        head = tail = node;
    }

    // Subsequent node.
    else
    {
        tail->next = node;
        tail = node;
    }

    node->next = nullptr;
    size++;
}

void LinkedList::clear()
{
    // Repeatedly delete the head node until the list is empty.
    while (head != nullptr)
    {
        Node *next = head->next;
        delete head;
        head = next;
    }

    tail = nullptr;
    size = 0;
}

void LinkedList::print() const
{
    for (Node *ptr = head; ptr != nullptr; ptr = ptr->next)
    {
        cout << " " << ptr->element.get_value();
    }
    cout << endl;
}

void LinkedList::split(LinkedList& list1, LinkedList& list2)
{
    int half_size1 = size/2;
    int half_size2 = size%2 == 0 ? half_size1 : half_size1 + 1;

    // Get to the node at the midpoint.
    Node *mid = head;
    for (int i = 1; i < half_size1; i++) mid = mid->next;
    Node *mid_next = mid->next;

    // Create the two sublists.
    list1.set(head, mid, half_size1);
    list2.set(mid_next, tail, half_size2);
}

void LinkedList::concatenate(LinkedList& other_list)
{
    // Splice the other list to the end of this list.
    tail->next = other_list.get_head();
    tail = other_list.get_tail();
    size += other_list.get_size();

    other_list.reset();
}
